diff -r 3d6cb39da268 src/http/ngx_http_core_module.c
--- a/src/http/ngx_http_core_module.c	Wed Apr 24 13:59:45 2013 +0000
+++ b/src/http/ngx_http_core_module.c	Sat Apr 27 12:37:29 2013 +0800
@@ -3843,6 +3843,15 @@ ngx_http_core_merge_loc_conf(ngx_conf_t 
     ngx_conf_merge_msec_value(conf->resolver_timeout,
                               prev->resolver_timeout, 30000);
 
+    if (conf->lingering_time < conf->lingering_timeout) {
+        ngx_conf_log_error(NGX_LOG_EMERG, cf, 0,
+            "\"lingering_time\" %Mms must be equal to or greater than "
+            "the value of \"lingering_timeout\" %Mms",
+            conf->lingering_time, conf->lingering_timeout);
+
+        return NGX_CONF_ERROR;
+    }
+
     if (conf->resolver == NULL) {
 
         if (prev->resolver == NULL) {
diff -r 3d6cb39da268 src/http/ngx_http_request.c
--- a/src/http/ngx_http_request.c	Wed Apr 24 13:59:45 2013 +0000
+++ b/src/http/ngx_http_request.c	Sat Apr 27 12:37:29 2013 +0800
@@ -3167,7 +3167,7 @@ ngx_http_lingering_close_handler(ngx_eve
     }
 
     timer = (ngx_msec_t) (r->lingering_time - ngx_time());
-    if (timer <= 0) {
+    if ((ngx_msec_int_t) timer <= 0) {
         ngx_http_close_request(r, 0);
         return;
     }
diff -r 3d6cb39da268 src/http/ngx_http_request_body.c
--- a/src/http/ngx_http_request_body.c	Wed Apr 24 13:59:45 2013 +0000
+++ b/src/http/ngx_http_request_body.c	Sat Apr 27 12:37:29 2013 +0800
@@ -571,7 +571,7 @@ ngx_http_discarded_request_body_handler(
     if (r->lingering_time) {
         timer = (ngx_msec_t) (r->lingering_time - ngx_time());
 
-        if (timer <= 0) {
+        if ((ngx_msec_int_t) timer <= 0) {
             r->discard_body = 0;
             r->lingering_close = 0;
             ngx_http_finalize_request(r, NGX_ERROR);
